#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>



int main(int argc, char **argv)
{
  int fd;
  struct termios options;
  char buff;
  int nbytes,opt, s=0, g=0, sc=0;
  char port[255];
  char tosend[8], toclear[8], toset[8];
  int i=0;


  memset(toclear, '0', 8);
  memset(toset, '0', 8);
  memset(tosend, '0', 8);
  memset(port, '\0', 255);

    /* read command line argument's */
	while((opt = getopt(argc, argv, "1:2:3:4:5:6:7:8:p:s:g")) != -1)
	{
		switch(opt)
		{
			case 'p':
				if(strlen(optarg) > 255)
				{
					fprintf(stderr, "%s: Invalid port name\n",argv[0]);
					exit(EXIT_FAILURE);
				}
				strcpy(port, optarg);
				break;
			case 's':
				s=1;
				strncpy(tosend, optarg,8);
				break;
			case 'g':
				g=1;
				break;
			case '1':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[0] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[0] = '1';
				break;
			case '2':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[1] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[1] = '1';
				break;
			case '3':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[2] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[2] = '1';
				break;
			case '4':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[3] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[3] = '1';
				break;
			case '5':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[4] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[4] = '1';
				break;
			case '6':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[5] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[5] = '1';
				break;
			case '7':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[6] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[6] = '1';
				break;
			case '8':
				sc = 1;
				if(strcmp(optarg,"on")==0)
					toset[7] = '1';
				else if(strcmp(optarg,"off")==0)
					toclear[7] = '1';
				break;
			default:
				fprintf(stderr, "Usage: %s -p port [-s (8bit data)] [-g] [-1..8 (on|off)]\n",argv[0]);
				exit(EXIT_FAILURE);
		}
	}

	if(port[0] == '\0') 
	{
		fprintf(stderr, "Usage: %s -p port [-s (8bit data)] [-g] [-1..8 (on|off)]\n",argv[0]);
		exit(EXIT_FAILURE);
	}


	/* open the port */
	fd = open(port, O_RDWR | O_NOCTTY | O_NDELAY);
	if(fd == -1)
	{
		printf("Error opening %s!\n",port);
		return 0;
	}
	fcntl(fd, F_SETFL, FNDELAY);

	/* get the current options */
	tcgetattr(fd, &options);

	/* set transmission speed */
	cfsetispeed(&options, B9600);
	cfsetospeed(&options, B9600);
	    	
	/* set type of transmision to 8N1 */
	options.c_cflag &= ~PARENB;
	options.c_cflag &= ~CSTOPB;
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;
	
	/* set raw input, 1 second timeout */
	options.c_cflag     |= (CLOCAL | CREAD);
	options.c_lflag     &= ~(ICANON | ISIG);
	//options.c_oflag     &= ~OPOST;
	options.c_cc[VMIN]  = 0;
	options.c_cc[VTIME] = 10;

	/* set the options */
	tcsetattr(fd, TCSANOW, &options);
	
	if(s==1)
	{
		write(fd, "s", 1);
		write(fd,tosend,8);
		write(fd, "s", 1);
		usleep(20000);
		while((nbytes = read(fd,&buff,1))>0)
		{
			printf("%c",buff);
		}
	}

	if(g==1)
	{
		write(fd, "g", 1);
		usleep(20000);
		while((nbytes = read(fd,&buff,1))>0)
		{
			printf("%c",buff);
		}
	}

	if(sc == 1)
	{
		write(fd, "g", 1);
		usleep(20000);
		while((nbytes = read(fd,&buff,1))>0)
		{
			if(i == 8)
				break;
			if(toset[i]=='1')
				tosend[i] = '1';
			else if(toclear[i]=='1')
				tosend[i] = '0';
			else
				tosend[i] = buff;
			i++;
		}	

		write(fd, "s", 1);
		write(fd, tosend, 8);
		write(fd, "s", 1);
		usleep(20000);
		while((nbytes = read(fd,&buff,1))>0)
		{
			printf("%c",buff);
		}
	}
	
	/* close port */
	close(fd);
 return 0;
} // end of main
